package com.link.core.util;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.google.gson.JsonParser;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class JsonUtil {
   private static final Logger logger = LogManager.getLogger(JsonUtil.class);

   public static void main(String[] args) {
      System.out.println("abcd".substring(0, "abcd".length() - 1));
   }

   public static JSONObject toJsonObject(String jsonString) {
      return JSONObject.parseObject(jsonString);
   }

   public static <T> T fromJsonStringToT(String jsonString, Class<T> clazz) {
      return JSONObject.parseObject(jsonString, clazz);
   }

   public static String toString(Object object) {
      return JSONObject.toJSONString(object);
   }

   public static String listToStringIncludeArrays(List list, String[] arrays) {
      List result = new ArrayList();
      Iterator var3 = list.iterator();

      while(var3.hasNext()) {
         Object object = var3.next();
         Map<String, Object> map = objectToMapIncludeArrays(object, arrays);
         result.add(map);
      }

      return JSONObject.toJSONString(result);
   }

   public static String objectToStringIncludeArrays(Object object, String[] arrays) {
      Map<String, Object> result = objectToMapIncludeArrays(object, arrays);
      return JSONObject.toJSONString(result);
   }

   public static String objectFieldsNameToString(Class classT) {
      StringBuilder ret = new StringBuilder();
      Field[] fields = classT.getDeclaredFields();
      Field[] var3 = fields;
      int var4 = fields.length;

      for(int var5 = 0; var5 < var4; ++var5) {
         Field field = var3[var5];
         String currentFieldName = field.getName();
         if (ret.length() > 0) {
            ret.append(",").append(currentFieldName);
         } else {
            ret.append(currentFieldName);
         }
      }

      return ret.toString();
   }

   private static Map<String, Object> objectToMapIncludeArrays(Object object, String[] arrays) {
      Map<String, Object> result = new HashMap();
      String[] var3 = arrays;
      int var4 = arrays.length;

      for(int var5 = 0; var5 < var4; ++var5) {
         String array = var3[var5];
         if (object instanceof Map) {
            result.put(array, ((Map)object).get(array));
         } else {
            try {
               Object value = getFieldValueByObject(object, array);
               boolean isId = null != value && ("id".equalsIgnoreCase(array) || "parentId".equalsIgnoreCase(array));
               if (isId) {
                  result.put(array, value.toString());
               } else {
                  result.put(array, value);
               }
            } catch (Exception var9) {
               Exception e = var9;
               logger.error(e.getMessage());
            }
         }
      }

      return result;
   }

   private static Object getFieldValueByObject(Object object, String targetFieldName) throws Exception {
      Class objClass = object.getClass();
      Field[] fields = objClass.getDeclaredFields();
      Field[] var4 = fields;
      int var5 = fields.length;

      for(int var6 = 0; var6 < var5; ++var6) {
         Field field = var4[var6];
         String currentFieldName = field.getName();
         if (currentFieldName.equals(targetFieldName)) {
            field.setAccessible(true);
            return field.get(object);
         }
      }

      Class superClass = objClass.getSuperclass();
      if (null != superClass) {
         Field[] superFields = superClass.getDeclaredFields();
         Field[] var13 = superFields;
         int var14 = superFields.length;

         for(int var15 = 0; var15 < var14; ++var15) {
            Field superField = var13[var15];
            String currentFieldName = superField.getName();
            if (currentFieldName.equals(targetFieldName)) {
               superField.setAccessible(true);
               return superField.get(object);
            }
         }
      }

      return null;
   }

   public static boolean isJSONStr(String jsonStr) {
      try {
         JSON.parse(jsonStr);
         return true;
      } catch (Exception var2) {
         return false;
      }
   }

   public static boolean isGsonStr(String jsonStr) {
      try {
         (new JsonParser()).parse(jsonStr);
         return true;
      } catch (Exception var2) {
         return false;
      }
   }
}
